#include <sys/klog.h>
#include <stdio.h>

#include "ansi.h"
#include "caronte.h"
#include "hardware.h"


int main(int argc, char **argv ) {
  int iret;
  TChain     *lista_distribuzioni;	// Elenco dei device contenenti una distribuzione
  TComputer  *tuxbox;

  // Parse /proc/cmdline
  // BOOT_IMAGE=treno ro root=303 ramdisk=0 PROFILE=TRENO

  // Show a gracefull intro
  logo_caronte();

  // lower kernel verbosity level
  klogctl( 8, NULL, 4);

  // Allocate computer and query devices
  tuxbox = create_computer();
  
  // Probe all the partitions
  iret = probe_partitions(tuxbox);

  // Search for all distributions
  lista_distribuzioni = probe_distributions(tuxbox);

  if (lista_distribuzioni==NULL) {
    printf("Lista distribuzioni is NULL\n");
  } else {
    printf("Distribuzioni trovate: %i \n", lista_distribuzioni->count);
  }
  return 0;
}
