#include <sys/mount.h>
#include <sys/stat.h>
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#include "ansi.h"
#include "caronte.h"
#include "file_exists.h"
#include "makedir.h"
#include "hardware.h"
#include "press_any_key.h"

TChain *probe_distributions(TComputer *computer) {
  TChain     *lpchain = NULL;
  TChainItem *item  = NULL;
  TPartition *pdata = NULL;
  TChainItem *pitem = NULL;
  int iret;
  assert(computer!=NULL);
  
  // Print Title  
  titolo_caronte();
  printf( "\n" );
  printf( "                        Ricerca Distribuzione\n\n" );
  printf( " Device      Versione                                  Tipo\n" );
  printf( " ==========  ========================================  ==================\n" );
  
  // Make Mount Point
  makedir(CARONTE_SOURCE_DIR, S_IRWXU);

  // Make sure it is unmounted
  umount(CARONTE_SOURCE_DIR);

  // Mounting Loop
  if (computer->partitions == NULL) {
    printERROR("             Nessuna partizione disponibile !\n");
    normal_color();
    press_any_key();
    return NULL;
  }
  
  // Mount all the partition from the list
  for( item=computer->partitions->head; item!=NULL ; item=item->next) {
    pdata = TPARTITION(item->data);
    if ( 0 == strcmp(pdata->filesystem, FILESYSTEM_NONE)) continue;
    if ( 0 == strcmp(pdata->filesystem, FILESYSTEM_SWAP)) continue;
    //printf("%s, %s \n", first->name, first->fstype );
    iret = mount( 
      pdata->device, CARONTE_SOURCE_DIR, pdata->filesystem, 
      MS_MGC_VAL || MS_RDONLY,
      NULL
    );

    // Errore nel mounting
    if (iret!=0) {
      printf(" %-10s  %-40s  %s\n", pdata->device, "Impossibile montare la partizione", pdata->filesystem );
      continue;
    }

    // Controllo presenza distribuzione
    if ( 0 == file_exists(CARONTE_SOURCE_PKG_DIR)) {
      //TODO: ricava versione della distribuzione
      printf(" %-10s  %-40s  %s\n", pdata->device, "Bad Pennguin x.y.z", pdata->filesystem );
      if (lpchain==NULL) lpchain=chain_create();
      pitem = chain_append(lpchain);
      pitem->name = "Bad Penguin x.y.z"; //TODO: nome distribuzione
      pitem->data = pdata;
    } else {
      printf(" %-10s  %-40s  %s\n", pdata->device, "Non contiene la distribuzione", pdata->filesystem );
    }      
    iret = umount(pdata->device);
    if (iret!=0) {
      printERROR("             Errore nello smontare la partizione !");
      normal_color();
    }
  }
  
  press_any_key();
  return lpchain;
}
