#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#include "caronte.h"
#include "hardware.h"
#include "press_any_key.h"

int probe_partitions(TComputer *computer) {
  TChainItem   *item = NULL;
  TChainItem   *pitem = NULL;
  TBlockDevice *pdata = NULL;
  TPartition   *ppdata = NULL;
  int iret = 0;
  assert(computer!=NULL);
  
  // Print Title  
  titolo_caronte();
  printf( "\n" );
  printf( "                        Ricerca dischi e Partizioni\n\n" );
  printf( " Device      Modello                         Tipo\n" );
  printf( " ==========  ==============================  ============================\n" );

  iret = query_eide_devices(computer);
  iret = query_scsi_devices(computer);
  iret = query_partitions(computer);
  
  if (computer->eide == NULL){
    printf("             Nessun dispositivo EIDE trovato\n");
  } else {
    for ( item=computer->eide->head; item!=NULL; item=item->next ) {
      pdata = item->data;
      printf(" %-10s  %-30s  %-15s\n", pdata->device, pdata->model, pdata->media );
      // Print partitions
      if (pdata->partitions != NULL) {
        for ( pitem=pdata->partitions->head; pitem!=NULL; pitem=pitem->next ) {
	  ppdata = pitem->data;
	  if ( 0 == strcmp(ppdata->filesystem,FILESYSTEM_NONE)) {
            printf(" %-10s  Filesystem di %10li Kb     %-15s\n", ppdata->device, ppdata->size, ppdata->filesystem );
	  } else {
	    printf(" %-10s  Partizione di %10li Kb     %-15s\n", ppdata->device, ppdata->size, ppdata->filesystem );
          }	    
	}
      }
    }
  }

  if (computer->scsi == NULL){
    printf("             Nessun dispositivo SCSI trovato\n");
  } else {
    for ( item=computer->scsi->head; item!=NULL; item=item->next ) {
      pdata = item->data;
      printf(" %-10s  %-30s  %-15s\n", pdata->device, pdata->model, pdata->media );
      // Print partitions
      if (pdata->partitions != NULL) {
        for ( pitem=pdata->partitions->head; pitem!=NULL; pitem=pitem->next ) {
	  ppdata = pitem->data;
	  if ( 0 == strcmp(ppdata->filesystem,FILESYSTEM_NONE)) {
            printf(" %-10s  Filesystem di %10li Kb     %-15s\n", ppdata->device, ppdata->size, ppdata->filesystem );
	  } else {
	    printf(" %-10s  Partizione di %10li Kb     %-15s\n", ppdata->device, ppdata->size, ppdata->filesystem );
          }	    
	}
      }
    }
  }

#ifdef PIPPO
  // Query EIDE
  iret = query_eide_devices(computer);
  if (computer->eide == NULL){
    printf(" Nessun dispositivo EIDE trovato\n");
  } else {
    for ( item=computer->eide->head; item!=NULL; item=item->next ) {
      pdata = item->data;
      printf(" %-10s  %-30s  %-15s\n", pdata->device, pdata->model, pdata->media );
      // Query partitions
      query_partitions_device(pdata);
      if (pdata->partitions != NULL) {
        for ( pitem=pdata->partitions->head; pitem!=NULL; pitem=pitem->next ) {
	  ppdata = pitem->data;
	  if ( 0 == strcmp(ppdata->filesystem,FILESYSTEM_NONE)) {
            printf(" %-10s  Filesystem di %10li Kb     %-15s\n", ppdata->device, ppdata->size, ppdata->filesystem );
	  } else {
	    printf(" %-10s  Partizione di %10li Kb     %-15s\n", ppdata->device, ppdata->size, ppdata->filesystem );
          }	    
	}
      }
    }
  }
  
  // Query SCSI
  iret = query_scsi_devices(computer);
  if (computer->scsi == NULL){
    printf(" Nessun dispositivo SCSI trovato\n");
  } else {
    for ( item=computer->scsi->head; item!=NULL; item=item->next ) {
      pdata = item->data;
      printf(" %-10s  %-30s  %-15s\n", pdata->device, pdata->model, pdata->media );
      // Query partitions
      query_partitions_device(pdata);
      if (pdata->partitions != NULL) {
        for ( pitem=pdata->partitions->head; pitem!=NULL; pitem=pitem->next ) {
	  ppdata = pitem->data;
	  if ( 0 == strcmp(ppdata->filesystem,FILESYSTEM_NONE)) {
            printf(" %-10s  Filesystem di %10li Kb     %-15s\n", ppdata->device, ppdata->size, ppdata->filesystem );
	  } else {
	    printf(" %-10s  Partizione di %10li Kb     %-15s\n", ppdata->device, ppdata->size, ppdata->filesystem );
          }	    
	}
      }
    }
  }
#endif

  // Debug
  press_any_key();
  
  return 0;
}
