#include <assert.h>
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include <unistd.h>

#include "ansi.h"
//#include "caronte.h"
#include "chain.h"
//#include "concatenate.h"
#include "file_exists.h"
#include "hardware.h"
#include "read_line.h"
//#include "runcommand.h"


TBlockDevice *create_scsi_device() {
  return calloc(1, sizeof(TBlockDevice));
}




int query_scsi_devices(TComputer *pc) {
  TChainItem *pcurrent = NULL;
  TBlockDevice *pdata = NULL;
  FILE *fd = NULL;
  char sda[] = "/dev/sda";			// Count SCSI disks
  char *tempstr = NULL;
  char *tempdata = NULL;
  tempstr  = calloc( 256, sizeof(char) );
  tempdata = calloc( 256, sizeof(char) );

  assert(pc!=NULL);
  // Clean Up previous Eide Chain
  if (pc->scsi!=NULL) {
    chain_delete(pc->scsi);
  }

  // Controlla presenza SCSI
  if ( 0 != file_exists(DIR_PROC_SCSI) ) {
    printERROR("Directory %s inesistente !\n", DIR_PROC_SCSI );
    normal_color();
    return 1;
  }

  // Apre file SCSI
  fd = fopen(FILE_PROC_SCSI,"r");
  if (fd==NULL) {
    printERROR("Impossibile aprire file %s\n", FILE_PROC_SCSI);
    normal_color();
    return 1;
  }

  // Cerca devices
  while (! feof(fd) ) {
    read_line(fd, tempstr);
    //printf(">%s\n", tempstr);
    
    // ... if vendore store it temporary
    if ( NULL != strstr(tempstr, "Vendor:")) {
      strncpy(tempdata, tempstr+10, 9);
      strncpy(tempdata+9, tempstr+26, 17 );
      tempdata[26]=0;
      //printf("VENDOR=%s\n", tempdata);
    } else
    if ( NULL != strstr(tempstr, "Type:")) {

      // Type checking: HARD DISKS
      if ( NULL != strstr(tempstr, MEDIA_DISK_SCSI)) {  
        // Crea la lista dei device SCSI se assente
        if (pc->scsi==NULL) pc->scsi=chain_create();
	
        //printf("Scsi dev =%s\n", sda);
	pcurrent = chain_append(pc->scsi);
	pcurrent->name   = strdup(sda);
	pcurrent->data   = create_scsi_device();
	pdata            = pcurrent->data;
        pdata->device    = strdup(pcurrent->name);
	pdata->model     = strdup(tempdata);
	pdata->media     = MEDIA_DISK_SCSI;
	//CHECK printf(" %-10s  %-30s  %-15s\n", current->name, current->model, "SCSI Disk" );
        //probe_cfdisk(first, current->name);
	// Increment scsi device name
	(sda[7])++;
        //printf("Scsi dev =%s\n", sda);
      }
    }
  }
  fclose(fd);

#ifdef PIPPO


  TPartition *current = NULL;
//  DIR *lpdir = NULL;
//  struct dirent *lpdirent = NULL;


#endif
  return 0;
}
